Package org.springframework.cache.annotation

# Annotation Interface CacheEvict

@Target({TYPE,METHOD}) @Retention(RUNTIME) @Inherited @Documented @Reflective public @interface CacheEvict
Annotation indicating that a method (or all methods on a class) triggers a `cache evict` operation.

This annotation may be used as a meta-annotation to create custom composed annotations with attribute overrides.

Since:
  3.1
Author:
  Costin Leau, Stephane Nicoll, Sam Brannen
See Also:
  - `CacheConfig`
  - `Cacheable`
  - `CachePut`

## Optional Element Summary

Optional Elements
Modifier and Type
Optional Element
Description
`boolean`
`allEntries`
Whether all the entries inside the cache(s) are removed.
`boolean`
`beforeInvocation`
Whether the eviction should occur before the method is invoked.
`String`
`cacheManager`
The bean name of the custom `CacheManager` to use to create a default `CacheResolver` if none is set already.
`String[]`
`cacheNames`
Names of the caches to use for the cache eviction operation.
`String`
`cacheResolver`
The bean name of the custom `CacheResolver` to use.
`String`
`condition`
Spring Expression Language (SpEL) expression used for making the cache eviction operation conditional.
`String`
`key`
Spring Expression Language (SpEL) expression for computing the key dynamically.
`String`
`keyGenerator`
The bean name of the custom `KeyGenerator` to use.
`String[]`
`value`
Alias for `cacheNames()`.

## Element Details

### value

@AliasFor("cacheNames") String[] value
Alias for `cacheNames()`.

Intended to be used when no other attributes are needed, for example: `@CacheEvict("books")`.

Default:
  {}

### cacheNames

@AliasFor("value") String[] cacheNames
Names of the caches to use for the cache eviction operation.

Names may be used to determine the target cache (or caches), matching the qualifier value or bean name of a specific bean definition.

Since:
  4.2
See Also:
  - `value()`
  - `CacheConfig.cacheNames()`

Default:
  {}

### key

String key
Spring Expression Language (SpEL) expression for computing the key dynamically.

Default is `""`, meaning all method parameters are considered as a key, unless a custom `keyGenerator()` has been set.

The SpEL expression evaluates against a dedicated context that provides the following meta-data:

- `#result` for a reference to the result of the method invocation, which can only be used if `beforeInvocation()` is `false`. For supported wrappers such as `Optional`, `#result` refers to the actual object, not the wrapper
- `#root.method`, `#root.target`, and `#root.caches` for references to the `method`, target object, and affected cache(s) respectively.
- Shortcuts for the method name (`#root.methodName`) and target class (`#root.targetClass`) are also available.
- Method arguments can be accessed by index. For instance the second argument can be accessed via `#root.args[1]`, `#p1` or `#a1`. Arguments can also be accessed by name if that information is available.

Default:
  ""

### keyGenerator

String keyGenerator
The bean name of the custom `KeyGenerator` to use.

Mutually exclusive with the `key()` attribute.

See Also:
  - `CacheConfig.keyGenerator()`

Default:
  ""

### cacheManager

String cacheManager
The bean name of the custom `CacheManager` to use to create a default `CacheResolver` if none is set already.

Mutually exclusive with the `cacheResolver()` attribute.

See Also:
  - `SimpleCacheResolver`
  - `CacheConfig.cacheManager()`

Default:
  ""

### cacheResolver

String cacheResolver
The bean name of the custom `CacheResolver` to use.

See Also:
  - `CacheConfig.cacheResolver()`

Default:
  ""

### condition

String condition
Spring Expression Language (SpEL) expression used for making the cache eviction operation conditional. Evict that cache if the condition evaluates to `true`.

Default is `""`, meaning the cache eviction is always performed.

The SpEL expression evaluates against a dedicated context that provides the following meta-data:

- `#root.method`, `#root.target`, and `#root.caches` for references to the `method`, target object, and affected cache(s) respectively.
- Shortcuts for the method name (`#root.methodName`) and target class (`#root.targetClass`) are also available.
- Method arguments can be accessed by index. For instance the second argument can be accessed via `#root.args[1]`, `#p1` or `#a1`. Arguments can also be accessed by name if that information is available.

Default:
  ""

### allEntries

boolean allEntries
Whether all the entries inside the cache(s) are removed.

By default, only the value under the associated key is removed.

Note that setting this parameter to `true` and specifying a `key()` is not allowed.

Default:
  false

### beforeInvocation

boolean beforeInvocation
Whether the eviction should occur before the method is invoked.

Setting this attribute to `true`, causes the eviction to occur irrespective of the method outcome (i.e., whether it threw an exception or not).

Defaults to `false`, meaning that the cache eviction operation will occur after the advised method is invoked successfully (i.e. only if the invocation did not throw an exception).

Default:
  false